#!/usr/bin/python -u
"""
    Pytecache is a GnutellaNet hosts cachter cacher servant.
    Copyright (C) 2000  Tom Goulet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    I can be reached at tomg@nova.yi.org.
"""
import pytella			# Hopefully all the functions I need.

def main():
	hosts = pytella.loadhosts()
	print "Hosts loaded."
	s = pytella.listen(('', 6346))
	print "Pytella listening."
	conns = []
	while 1:
		connectionloop(s, hosts)
	return()

def connectionloop(s, hosts):
	print "Waiting for connection."
 	try: conn, addr = pytella.accept(s)
	except pytella.AcceptError: return()
	print "Connection established from:", addr
	rheader = ''
	for i in range(10):
                try: rheader, rpayload = pytella.recv(conn) ; break
                except pytella.RecvError: pass
	if len(rheader) != 23:
		conn.close()
		return()
	guid, func, ttl, hops, length = pytella.parseheader(rheader)
        if func == 'ping':
                print "Got ping."
                ttl = 0
                hops = 0
                for host in hosts:
			try: pytella.sendpong(conn, guid, ttl, hops, host)
			except pytella.SendError:
				conn.close()
				return()
                print "Pong flood accomplished."
		conn.close()
                return()
	else:
		conn.close()
		return()
	print "I shouldn't get here!"
	conn.close()
	return()

main()
